stages:
  - build
  - deploy

variables:
  CI_REGISTRY_BRANCH_IMAGE: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME

.docker-build:
  image: docker:18.09
  services:
    - docker:dind
  variables:
    - DOCKER_HOST: tcp://localhost:2375
    - DOCKER_DRIVER: overlay2
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - '[ -z "$CACHE_LAYER" ] && docker build --pull -f $CI_COMMIT_REF_NAME.Dockerfile --tag $CI_REGISTRY_BRANCH_IMAGE:$CI_COMMIT_SHA --tag $CI_REGISTRY_BRANCH_IMAGE:latest . || echo "skipped"'
    
    - '[ ! -z "$CACHE_LAYER" ] && (docker pull $CI_REGISTRY_BRANCH_IMAGE:$CACHE_LAYER || true) || echo "skipped"'
    - '[ ! -z "$CACHE_LAYER" ] && docker build --cache-from $CI_REGISTRY_BRANCH_IMAGE:$CACHE_LAYER -f $CI_COMMIT_REF_NAME.Dockerfile --tag $CI_REGISTRY_BRANCH_IMAGE:$CACHE_LAYER --target $CACHE_LAYER . || echo "skipped"'
    - '[ ! -z "$CACHE_LAYER" ] && docker push $CI_REGISTRY_BRANCH_IMAGE:$CACHE_LAYER || echo "skipped"'
    - '[ ! -z "$CACHE_LAYER" ] && docker build --cache-from $CI_REGISTRY_BRANCH_IMAGE:$CACHE_LAYER -f $CI_COMMIT_REF_NAME.Dockerfile --tag $CI_REGISTRY_BRANCH_IMAGE:$CI_COMMIT_SHA --tag $CI_REGISTRY_BRANCH_IMAGE:latest . || echo "skipped"'
  after_script:
    - docker push $CI_REGISTRY_BRANCH_IMAGE:$CI_COMMIT_SHA
    - docker push $CI_REGISTRY_BRANCH_IMAGE:latest

.ssh-deployment:
  image: registry.gitlab.com/ebs-agency/docker-ci-cd/ssh:latest
  before_script:
    - '[ $SSH_MODE = "PASS" ] && (echo "SSH PASS mode enabled")'
    - '[ $SSH_MODE = "KEY" ] && (echo "SSH KEY mode enabled")'
    ###### checking SSH_MODE
    - '([ $SSH_MODE != "PASS" ] && [ $SSH_MODE != "KEY" ]) && echo "invalid SSH mode" && exit 1'
    ###### ssh pass connection mode
    - '[ $SSH_MODE = "PASS" ] && alias ssh="sshpass -e ssh" && alias scp="sshpass -e scp"'

    - '[ $SSH_MODE = "PASS" ] && export SSHPASS=$SSH_PASS'
    ###### ssh key connection mode
    - '[ $SSH_MODE = "KEY" ] && eval $(ssh-agent -s)'
    - '[ $SSH_MODE = "KEY" ] && (cat $SSH_KEY || echo "$SSH_KEY" | tr -d "\r" | ssh-add -)'

    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
  script:
    - ssh $SSH_USER@$SSH_SERVER "sudo docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY"
    - ssh $SSH_USER@$SSH_SERVER "sudo docker pull $CI_REGISTRY_BRANCH_IMAGE:latest"
    - ssh $SSH_USER@$SSH_SERVER "sudo docker service update $SERVICE_NAME --image $CI_REGISTRY_BRANCH_IMAGE:latest --force"
    - ssh  $SSH_USER@$SSH_SERVER "sudo docker system prune -f || true"

.docker-ssh-deployment:
  image: registry.gitlab.com/ebs-agency/docker-ci-cd/ssh:latest
  before_script:
    - '[ $SSH_MODE = "PASS" ] && (echo "SSH PASS mode enabled")'
    - '[ $SSH_MODE = "KEY" ] && (echo "SSH KEY mode enabled")'
    ###### checking SSH_MODE
    - '([ $SSH_MODE != "PASS" ] && [ $SSH_MODE != "KEY" ]) && echo "invalid SSH mode" && exit 1'
    ###### ssh pass connection mode
    - '[ $SSH_MODE = "PASS" ] && alias ssh="sshpass -e ssh" && alias scp="sshpass -e scp"'

    - '[ $SSH_MODE = "PASS" ] && export SSHPASS=$SSH_PASS'
    ###### ssh key connection mode
    - '[ $SSH_MODE = "KEY" ] && eval $(ssh-agent -s)'
    - '[ $SSH_MODE = "KEY" ] && (cat $SSH_KEY || echo "$SSH_KEY" | tr -d "\r" | ssh-add -)'

    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
    - chmod 700 $SSH_KEY
    - ssh -i $SSH_KEY $SSH_USER@$SSH_SERVER "sudo docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY"
    - ssh  -i $SSH_KEY $SSH_USER@$SSH_SERVER "sudo docker pull $CI_REGISTRY_BRANCH_IMAGE:latest"
    - ssh  -i $SSH_KEY $SSH_USER@$SSH_SERVER "sudo docker stop $SERVICE_NAME || true && sudo docker rm $SERVICE_NAME || true"
 
